﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Reflection;
using mscoree;

namespace ConsoleApplication1
{
    partial class Program
    {
        private static void ShowProcessInfo()
        {
            Console.WriteLine((IntPtr.Size == 4 ? "x86" : "x64") + ", Pid == " + Process.GetCurrentProcess().Id);
        }

        private static void DisplayAppDomains()
        {
            List<AppDomain> appDomains = new List<AppDomain>();
            IntPtr handle = IntPtr.Zero;
            CorRuntimeHost host = new CorRuntimeHost();

            try
            {
                host.EnumDomains(out handle);

                while (true)
                {
                    object domain;
                    host.NextDomain(handle, out domain);
                    if (domain == null)
                        break;
                    appDomains.Add((AppDomain)domain);
                }
            }
            finally
            {
                host.CloseEnum(handle);
            }

            foreach (AppDomain appDom in appDomains)
            {
                Console.WriteLine(appDom.FriendlyName);
            }
        }

    }
}
